<template>
  <div class="report">

    <div class="report__header">
      <div class="report__header__logo-wrapper"/>
    </div>

    <div class="report__content">

      <div class="report__content__indicator-title">{{ indicatorTitle }}</div>

      <div class="report__content__indicator-description">{{ indicatorDescription }}</div>

      <div class="report__content__user-query-parameters">
        <div v-for="item in dynamicHeader" :key="item">
          <span class="report__content__user-query-parameters__title">{{ item.title }}</span>
          <span class="report__content__user-query-parameters__value">{{ item.value }}</span>
        </div>
      </div>

      <div v-if="isColorMapNeeded" class="report__content__color-map-area">
        <ReportColorMapComponent
          :indicator="props.indicator"
          :data="data.colorMapData"
        />
      </div>
      <div class="report__content__chart-area">

        <ReportVerticalBarChartComponent
          v-if="isVerticalBarChartNeeded"
          :indicator="props.indicator"
          :data="data.chartData"
        />

        <ReportLineChartComponent
          v-if="isLineChartNeeded"
          :indicator="props.indicator"
          :data="data.chartData"
        />

        <ReportBoxPlotChartComponent
          v-if="isBoxPlotChartNeeded"
          :indicator="props.indicator"
          :data="data.chartData"
        />

        <ReportHorizontalBarChartComponent
          v-if="isHorizontalBarChartNeeded"
          :indicator="props.indicator"
          :data="data.chartData"
          style="min-width: 25cm"
        />
      </div>
    </div>

    <div class="report__footer">
      <div class="report__footer__rect" />

      <div class="report__footer__info-block">
        <div class="report__footer__info-block__organization-title"><span>Servicio Nacional de Contratación Pública</span></div>
        <div class="report__footer__info-block__organization-info"><span><b>Dirección:</b> Plataforma Gubernamental Financiera, Amazonas entre Unión Nacional de Periodistas y Alfonso Pereira, Bloque Amarillo, Piso 7</span></div>
        <div class="report__footer__info-block__organization-info"><span><b>Código postal:</b> 170506 / Quito-Ecuador</span></div>
        <div class="report__footer__info-block__organization-info"><span><b>Teléfono::</b> +594-2 244 0050 / www.sercop.gob.ec</span></div>
      </div>

      <div class="report__footer__logo-wrapper" />

    </div>
  </div>

</template>

<script setup>
import { computed } from 'vue';
import ReportColorMapComponent from './report-color-map-component/ReportColorMapComponent.vue';
import ReportLineChartComponent from './report-line-chart-component/ReportLineChartComponent.vue';
import ReportBoxPlotChartComponent from './report-box-plot-chart-component/ReportBoxPlotChartComponent.vue';
import ReportVerticalBarChartComponent from './report-vertical-bar-chart-component/ReportVerticalBarChartComponent.vue';
import ReportHorizontalBarChartComponent from './report-horizontal-bar-chart-component/ReportHorizontalBarChartComponent.vue';

const props = defineProps({
  indicator:            { type: String, required: true },
  indicatorTitle:       { type: String, required: true },
  indicatorDescription: { type: String, required: true },
  dynamicHeader:        { type: Array, required: true },
  data:                 { type: Object, required: true },
});

const indicatorTitle = computed({
  get: () => props.indicatorTitle,
});

const indicatorDescription = computed({
  get: () => props.indicatorDescription,
});

const dynamicHeader = computed({
  get: () => props.dynamicHeader,
});

const data = computed({
  get: () => props.data,
});

const isColorMapNeeded = computed(() => props.indicator !== 'indicator_16' && props.indicator !== 'indicator_17');
const isHorizontalBarChartNeeded = computed(() => ['indicator_5_6', 'indicator_7_8', 'indicator_12', 'indicator_13'].includes(props.indicator));
const isVerticalBarChartNeeded = computed(() => ['indicator_1_2', 'indicator_3_4'].includes(props.indicator));
const isBoxPlotChartNeeded = computed(() => props.indicator === 'indicator_16' || props.indicator === 'indicator_17');
const isLineChartNeeded = computed(() => ['indicator_9', 'indicator_10_11', 'indicator_14', 'indicator_15'].includes(props.indicator));

</script>

<style lang="scss" scoped>
@use './report-component-stylesheet.scss';
</style>